3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
30 if test -z "$TEST_OUTPUT_DIRECTORY"
32 # Similarly, override this to store the test-results subdir
34 TEST_OUTPUT_DIRECTORY
=$TEST_DIRECTORY
36 GIT_BUILD_DIR
="$TEST_DIRECTORY"/..
38 ################################################################
39 # It appears that people try to run tests without building...
40 "$GIT_BUILD_DIR/git" >/dev
/null
43 echo >&2 'error: you do not seem to have built git yet.'
47 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48 export PERL_PATH SHELL_PATH
50 # if --tee was passed, write the output not only to the terminal, but
51 # additionally to the file test-results/$BASENAME.out, too.
52 case "$GIT_TEST_TEE_STARTED, $* " in
54 # do not redirect again
56 *' --tee '*|
*' --va'*)
57 mkdir
-p "$TEST_OUTPUT_DIRECTORY/test-results"
58 BASE
="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
59 (GIT_TEST_TEE_STARTED
=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $?
> $BASE.
exit) |
tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
66 # For repeatability, reset the environment to known value.
72 export LANG LC_ALL PAGER TERM TZ
74 # A call to "unset" with no arguments causes at least Solaris 10
75 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76 # deriving from the command substitution clustered with the other
78 unset VISUAL EMAIL LANGUAGE COLUMNS $
("$PERL_PATH" -e '
80 my $ok = join("|", qw(
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
92 print join("\n", @vars);
96 GIT_AUTHOR_EMAIL
=author@example.com
97 GIT_AUTHOR_NAME
='A U Thor'
98 GIT_COMMITTER_EMAIL
=committer@example.com
99 GIT_COMMITTER_NAME
='C O Mitter'
100 GIT_MERGE_VERBOSITY
=5
101 GIT_MERGE_AUTOEDIT
=no
102 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
103 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
104 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
107 # Add libc MALLOC and MALLOC_PERTURB test
108 # only if we are not executing the test with valgrind
109 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev
/null ||
110 test -n "$TEST_NO_MALLOC_CHECK"
112 setup_malloc_check
() {
115 teardown_malloc_check
() {
119 setup_malloc_check
() {
120 MALLOC_CHECK_
=3 MALLOC_PERTURB_
=165
121 export MALLOC_CHECK_ MALLOC_PERTURB_
123 teardown_malloc_check
() {
124 unset MALLOC_CHECK_ MALLOC_PERTURB_
128 # Protect ourselves from common misconfiguration to export
129 # CDPATH into the environment
135 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
137 echo "* warning: Some tests will not work if GIT_TRACE" \
138 "is set as to trace on STDERR ! *"
139 echo "* warning: Please set GIT_TRACE to something" \
140 "other than 1, 2 or true ! *"
146 # A regexp to match 5 and 40 hexdigits
147 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
148 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
151 _z40
=0000000000000000000000000000000000000000
157 export _x05 _x40 _z40 LF
159 # Each test should start with something like this, after copyright notices:
161 # test_description='Description of this test...
162 # This test checks if command xyzzy does the right thing...
165 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
166 TERM
=$ORIGINAL_TERM &&
169 tput bold
>/dev
/null
2>&1 &&
170 tput setaf
1 >/dev
/null
2>&1 &&
171 tput sgr0
>/dev
/null
2>&1
175 while test "$#" -ne 0
178 -d|
--d|
--de|
--deb|
--debu|
--debug)
180 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
181 immediate
=t
; shift ;;
182 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
183 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
184 -h|
--h|
--he|
--hel|
--help)
186 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
189 verbose_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
191 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
192 # Ignore --quiet under a TAP::Harness. Saying how many tests
193 # passed without the ok/not ok details is always an error.
194 test -z "$HARNESS_ACTIVE" && quiet
=t
; shift ;;
196 with_dashes
=t
; shift ;;
199 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
203 valgrind
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
206 valgrind_only
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
209 shift ;; # was handled already
211 root
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
214 echo "error: unknown test option '$1'" >&2; exit 1 ;;
218 if test -n "$valgrind_only"
220 test -z "$valgrind" && valgrind
=memcheck
221 test -z "$verbose" && verbose_only
="$valgrind_only"
222 elif test -n "$valgrind"
235 tput bold
; tput setaf
1;; # bold red
237 tput setaf
4;; # blue
239 tput setaf
3;; # brown/yellow
241 tput setaf
2;; # green
243 tput setaf
6;; # cyan
245 test -n "$quiet" && return;;
255 test -z "$1" && test -n "$quiet" && return
262 say_color error
"error: $*"
271 test "${test_description}" != "" ||
272 error
"Test script did not set test_description."
274 if test "$help" = "t"
276 echo "$test_description"
282 if test "$verbose" = "t"
286 exec 4>/dev
/null
3>/dev
/null
295 test_external_has_tap
=0
299 if test -n "$GIT_EXIT_OK"
303 echo >&5 "FATAL: Unexpected exit with code $code"
311 # The user-facing functions are loaded from a separate file so that
312 # test_perf subshells can have them too
313 .
"$TEST_DIRECTORY/test-lib-functions.sh"
315 # You are not expected to call test_ok_ and test_failure_ directly, use
316 # the test_expect_* functions instead.
319 test_success
=$
(($test_success + 1))
320 say_color
"" "ok $test_count - $@"
324 test_failure
=$
(($test_failure + 1))
325 say_color error
"not ok $test_count - $1"
327 echo "$@" |
sed -e 's/^/# /'
328 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
331 test_known_broken_ok_
() {
332 test_fixed
=$
(($test_fixed+1))
333 say_color error
"ok $test_count - $@ # TODO known breakage vanished"
336 test_known_broken_failure_
() {
337 test_broken
=$
(($test_broken+1))
338 say_color warn
"not ok $test_count - $@ # TODO known breakage"
342 test "$debug" = "" ||
eval "$1"
345 match_pattern_list
() {
348 test -z "$*" && return 1
359 maybe_teardown_verbose
() {
360 test -z "$verbose_only" && return
361 exec 4>/dev
/null
3>/dev
/null
366 maybe_setup_verbose
() {
367 test -z "$verbose_only" && return
368 if match_pattern_list
$test_count $verbose_only
371 # Emit a delimiting blank line when going from
372 # non-verbose to verbose. Within verbose mode the
373 # delimiter is printed by test_expect_*. The choice
374 # of the initial $last_verbose is such that before
375 # test 1, we do not print it.
376 test -z "$last_verbose" && echo >&3 ""
379 exec 4>/dev
/null
3>/dev
/null
382 last_verbose
=$verbose
385 maybe_teardown_valgrind
() {
386 test -z "$GIT_VALGRIND" && return
387 GIT_VALGRIND_ENABLED
=
390 maybe_setup_valgrind
() {
391 test -z "$GIT_VALGRIND" && return
392 if test -z "$valgrind_only"
394 GIT_VALGRIND_ENABLED
=t
397 GIT_VALGRIND_ENABLED
=
398 if match_pattern_list
$test_count $valgrind_only
400 GIT_VALGRIND_ENABLED
=t
405 # This is a separate function because some tests use
406 # "return" to end a test_expect_success block early.
407 eval </dev
/null
>&3 2>&4 "$*"
416 teardown_malloc_check
418 if test -z "$immediate" ||
test $eval_ret = 0 ||
test -n "$expecting_failure"
421 test_eval_
"$test_cleanup"
422 teardown_malloc_check
424 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
432 test_count
=$
(($test_count+1))
439 maybe_teardown_valgrind
440 maybe_teardown_verbose
445 if match_pattern_list
$this_test.
$test_count $GIT_SKIP_TESTS
449 if test -z "$to_skip" && test -n "$test_prereq" &&
450 ! test_have_prereq
"$test_prereq"
457 if test "$missing_prereq" != "$test_prereq"
459 of_prereq
=" of $test_prereq"
462 say_color skip
>&3 "skipping test: $@"
463 say_color skip
"ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
472 # stub; perf-lib overrides it
473 test_at_end_hook_
() {
480 # Note: t0000 relies on $HARNESS_ACTIVE disabling the .counts
482 if test -z "$HARNESS_ACTIVE"
484 test_results_dir
="$TEST_OUTPUT_DIRECTORY/test-results"
485 mkdir
-p "$test_results_dir"
487 test_results_path
="$test_results_dir/${base%.sh}-$$.counts"
489 cat >>"$test_results_path" <<-EOF
491 success $test_success
499 if test "$test_fixed" != 0
501 say_color error
"# $test_fixed known breakage(s) vanished; please update test(s)"
503 if test "$test_broken" != 0
505 say_color warn
"# still have $test_broken known breakage(s)"
507 if test "$test_broken" != 0 ||
test "$test_fixed" != 0
509 test_remaining
=$
(( $test_count - $test_broken - $test_fixed ))
510 msg
="remaining $test_remaining test(s)"
512 test_remaining
=$test_count
513 msg
="$test_count test(s)"
515 case "$test_failure" in
517 # Maybe print SKIP message
518 if test -n "$skip_all" && test $test_count -gt 0
520 error
"Can't use skip_all after running some tests"
522 [ -z "$skip_all" ] || skip_all
=" # SKIP $skip_all"
524 if test $test_external_has_tap -eq 0
526 if test $test_remaining -gt 0
528 say_color pass
"# passed all $msg"
530 say
"1..$test_count$skip_all"
533 test -d "$remove_trash" &&
534 cd "$(dirname "$remove_trash")" &&
535 rm -rf "$(basename "$remove_trash")"
542 if test $test_external_has_tap -eq 0
544 say_color error
"# failed $test_failure among $msg"
553 if test -n "$valgrind"
557 test "$1" = "$(readlink "$2")" ||
{
565 while test -d "$2".lock
567 say
"Waiting for lock on $2."
574 make_valgrind_symlink
() {
575 # handle only executables, unless they are shell libraries that
576 # need to be in the exec-path. We will just use "#!" as a
577 # guess for a shell-script, since we have no idea what the user
578 # may have configured as the shell path.
580 test "#!" = "$(head -c 2 <"$1")" ||
583 base
=$
(basename "$1")
584 symlink_target
=$GIT_BUILD_DIR/$base
585 # do not override scripts
586 if test -x "$symlink_target" &&
587 test ! -d "$symlink_target" &&
588 test "#!" != "$(head -c 2 < "$symlink_target")"
590 symlink_target
=..
/valgrind.sh
594 symlink_target
=..
/unprocessed-script
596 # create the link, or replace it if it is out of date
597 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
600 # override all git executables in TEST_DIRECTORY/..
601 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
602 mkdir
-p "$GIT_VALGRIND"/bin
603 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/test-
*
605 make_valgrind_symlink
$file
607 # special-case the mergetools loadables
608 make_symlink
"$GIT_BUILD_DIR"/mergetools
"$GIT_VALGRIND/bin/mergetools"
613 ls "$path"/git-
* 2> /dev
/null |
616 make_valgrind_symlink
"$file"
620 PATH
=$GIT_VALGRIND/bin
:$PATH
621 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
623 GIT_VALGRIND_MODE
="$valgrind"
624 export GIT_VALGRIND_MODE
625 GIT_VALGRIND_ENABLED
=t
626 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED
=
627 export GIT_VALGRIND_ENABLED
628 elif test -n "$GIT_TEST_INSTALLED"
630 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
631 error
"Cannot run git from $GIT_TEST_INSTALLED."
632 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
633 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
634 else # normal case, use ../bin-wrappers only unless $with_dashes:
635 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
636 if ! test -x "$git_bin_dir/git"
638 if test -z "$with_dashes"
640 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
644 PATH
="$git_bin_dir:$PATH"
645 GIT_EXEC_PATH
=$GIT_BUILD_DIR
646 if test -n "$with_dashes"
648 PATH
="$GIT_BUILD_DIR:$PATH"
651 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
653 GIT_CONFIG_NOSYSTEM
=1
655 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
657 if test -z "$GIT_TEST_CMP"
659 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
661 GIT_TEST_CMP
="$DIFF -c"
663 GIT_TEST_CMP
="$DIFF -u"
667 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/blib
/lib
:"$GIT_BUILD_DIR"/perl
/blib
/arch
/auto
/Git
669 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
670 error
"You haven't built things yet, have you?"
673 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
675 echo >&2 'You need to build test-chmtime:'
676 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
681 TRASH_DIRECTORY
="trash directory.$(basename "$0" .sh)"
682 test -n "$root" && TRASH_DIRECTORY
="$root/$TRASH_DIRECTORY"
683 case "$TRASH_DIRECTORY" in
684 /*) ;; # absolute path is good
685 *) TRASH_DIRECTORY
="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
687 test ! -z "$debug" || remove_trash
=$TRASH_DIRECTORY
688 rm -fr "$TRASH_DIRECTORY" ||
{
690 echo >&5 "FATAL: Cannot prepare test area"
694 HOME
="$TRASH_DIRECTORY"
697 if test -z "$TEST_NO_CREATE_REPO"
699 test_create_repo
"$TRASH_DIRECTORY"
701 mkdir
-p "$TRASH_DIRECTORY"
703 # Use -P to resolve symlinks in our working directory so that the cwd
704 # in subprocesses like git equals our $PWD (for pathname comparisons).
705 cd -P "$TRASH_DIRECTORY" ||
exit 1
708 this_test
=${this_test%%-*}
709 if match_pattern_list
"$this_test" $GIT_SKIP_TESTS
711 say_color info
>&3 "skipping test $this_test altogether"
712 skip_all
="skip all tests in $this_test"
716 # Provide an implementation of the 'yes' utility
731 # Fix some commands on Windows
734 # Windows has its own (incompatible) sort and find
744 # git sees Windows-style pwd
748 # no POSIX permissions
749 # backslashes in pathspec are converted to '/'
750 # exec does not inherit the PID
751 test_set_prereq MINGW
752 test_set_prereq NOT_CYGWIN
753 test_set_prereq SED_STRIPS_CR
754 test_set_prereq GREP_STRIPS_CR
757 test_set_prereq POSIXPERM
758 test_set_prereq EXECKEEPSPID
759 test_set_prereq NOT_MINGW
760 test_set_prereq CYGWIN
761 test_set_prereq SED_STRIPS_CR
762 test_set_prereq GREP_STRIPS_CR
765 test_set_prereq POSIXPERM
766 test_set_prereq BSLASHPSPEC
767 test_set_prereq EXECKEEPSPID
768 test_set_prereq NOT_MINGW
769 test_set_prereq NOT_CYGWIN
773 ( COLUMNS
=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
774 test -z "$NO_PERL" && test_set_prereq PERL
775 test -z "$NO_PYTHON" && test_set_prereq PYTHON
776 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
777 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
779 # Can we rely on git's output in the C locale?
780 if test -n "$GETTEXT_POISON"
782 GIT_GETTEXT_POISON
=YesPlease
783 export GIT_GETTEXT_POISON
784 test_set_prereq GETTEXT_POISON
786 test_set_prereq C_LOCALE_OUTPUT
789 # Use this instead of test_cmp to compare files that contain expected and
790 # actual output from git commands that can be translated. When running
791 # under GETTEXT_POISON this pretends that the command produced expected
794 test -n "$GETTEXT_POISON" || test_cmp
"$@"
797 # Use this instead of "grep expected-string actual" to see if the
798 # output from a git command that can be translated either contains an
799 # expected string, or does not contain an unwanted one. When running
800 # under GETTEXT_POISON this pretends that the command produced expected
803 if test -n "$GETTEXT_POISON"
806 elif test "x!" = "x$1"
815 test_lazy_prereq PIPE
'
816 # test whether the filesystem supports FIFOs
822 rm -f testfifo && mkfifo testfifo
827 test_lazy_prereq SYMLINKS
'
828 # test whether the filesystem supports symbolic links
829 ln -s x y && test -h y
832 test_lazy_prereq CASE_INSENSITIVE_FS
'
833 echo good >CamelCase &&
834 echo bad >camelcase &&
835 test "$(cat CamelCase)" != good
838 test_lazy_prereq UTF8_NFD_TO_NFC
'
839 # check whether FS converts nfd unicode to nfc
840 auml=$(printf "\303\244")
841 aumlcdiar=$(printf "\141\314\210")
851 test_lazy_prereq AUTOIDENT
'
852 sane_unset GIT_AUTHOR_NAME &&
853 sane_unset GIT_AUTHOR_EMAIL &&
854 git var GIT_AUTHOR_IDENT
857 # When the tests are run as root, permission tests will report that
858 # things are writable when they shouldn't be.
859 test -w / || test_set_prereq SANITY
861 GIT_UNZIP
=${GIT_UNZIP:-unzip}
862 test_lazy_prereq UNZIP
'